/* Exercise 6. Book shop */

#include <stdio.h>
#include <string.h>

#define MAX_BOOKS 150
#define MAX_CHAR  128

struct Book {
	char title[MAX_CHAR];
	char author[MAX_CHAR];
	char keyword[MAX_CHAR];
	int year;
	int rank;
	int theme;
};

int main(void) {
    
	struct Book catalogue[MAX_BOOKS];
	struct Book bestSeller;
	int end, option;
	int i;
	int th, bestRank;
	int nBooks = 0;
    
	end = 0;
	do {
        
		/* Read option */
		printf("1. Add book \n");
		printf("2. List books \n");
		printf("3. Search best seller \n");
		printf("4. Exit \n");
		scanf("%i", &option); getchar();
        
		switch(option) {
			case 1: // add book at position nBooks if there is enough room
				if(nBooks < MAX_BOOKS)  {
					printf("\nAdding new book...\n");
					printf("title? ");
					scanf("%[^\n]", catalogue[nBooks].title); getchar();
					printf("author? ");
					scanf("%[^\n]", catalogue[nBooks].author); getchar();
					printf("keyword? ");
					scanf("%[^\n]", catalogue[nBooks].keyword); getchar();
					printf("publishing year? ");
					scanf("%i", &catalogue[nBooks].year);
					printf("rank? ");
					scanf("%i", &catalogue[nBooks].rank);
					do {
						printf("theme? \n");
						printf("  1. detectives \n");
						printf("  2. historical \n");
						printf("  3. computers \n");
						printf("  4. social sciences \n");
						printf("  5. essay \n");
						scanf("%i", &catalogue[nBooks].theme);
					} while(catalogue[nBooks].theme<1 || catalogue[nBooks].theme>5);
                    
					nBooks++;
				} else {
					printf("Maximum catalogue size has been reached. No more books allowed. \n");
				}
				break;
                
			case 2: // list all books
				for(i=0; i<nBooks; i++)
					printf("%i- %s (%s) - %i - [%s] [%i] (%ith) \n",
                           i+1,
                           catalogue[i].title,
                           catalogue[i].author,
                           catalogue[i].year,
                           catalogue[i].keyword,
                           catalogue[i].theme,
                           catalogue[i].rank);
				printf("\n");
				break;
                
			case 3: // list best seller in a theme
				do {
					printf("theme? \n");
					printf("  1. detectives \n");
					printf("  2. historical \n");
					printf("  3. computers \n");
					printf("  4. social sciences \n");
					printf("  5. essay \n");
					scanf("%i", &th);
				} while(th<1 || th>5);
                
				bestRank = 1000; // assuming that there is no rank larger or equal than 1000
				for(i=0; i<nBooks; i++)
					if(catalogue[i].theme == th && catalogue[i].rank <= bestRank) {
						bestSeller = catalogue[i];
						bestRank = catalogue[i].rank;
					}
                
				if(bestRank < 1000) {
					printf("\nThe best seller in category %i is: \n", th);
					printf("%s (%s) - %i - [%s] [%i] (%ith) \n",
                           bestSeller.title,
                           bestSeller.author,
                           bestSeller.year,
                           bestSeller.keyword,
                           bestSeller.theme,
                           bestSeller.rank);
				} else {
					printf("\nNo best seller in category %i \n", th);
				}
				printf("\n");
				break;
                
			case 4: // exit
				end = 1;
				break;
		}
        
	} while(!end);
    
    
	return 0;
}
